-- Lingo LPeg lexer.

--function dbg(str)
--	local f = io.open("C:\dbg.txt", "w+")
--	f:write(str)
--	f:close()
--end

--function dbg_table(t)
--	local str = ""
--	for k,v in pairs(t) do
--		str = str..k.."\t"..tostring(v).."\n" --k.."="..v.."\n"
--	end
--	local f = io.open("C:\dbg.txt", "w+")
--	f:write(str)
--	f:close()
--end

local function loadWords(...)
	local table = {}
	local i = 0
  for j,fn in ipairs(arg) do
		for line in io.lines(fn) do
			i = i+1
			table[i] = line
		end
  end
	return table
end

local l = require('lexer')

-- get path tp lingo api files
local pos = string.find (l.LEXERPATH, "?", 1, true)
local path = string.sub (l.LEXERPATH, 1, pos-1).."lingo/"


local token, word_match = l.token, l.word_match
local P, R, S = lpeg.P, lpeg.R, lpeg.S

local M = {_NAME = 'lingo'}

-- Whitespace.
local ws = token(l.WHITESPACE, l.space^1)

-- Comments.
local line_comment = '--' * l.nonnewline^0
local comment = token(l.COMMENT, line_comment)

-- Strings.
local string = token(l.STRING, l.delimited_range('"', true))

-- Numbers.
local number = token(l.NUMBER, l.float + l.integer)


-- KEYWORDS

local keyword = token(l.KEYWORD, word_match(loadWords(path.."keywords.txt"), nil, true))


-- FUNCTIONS

local func = token(l.FUNCTION, word_match(loadWords(path.."functions.txt",path.."properties.txt",path.."events.txt"), nil, true))


-- IDENTIFIERS

local identifier = token(l.IDENTIFIER, (l.alpha + '_') * l.alnum^0)


-- OPERATORS

--local operator = token(l.OPERATOR, S('+-^*/&<>=:,(){}'))
--local operator = token(l.OPERATOR, word_match(loadWords(path.."operators.txt"), nil, true))

--local constant = token(l.CONSTANT, word_match(loadWords(path.."constants.txt"), nil, true))

--local property = token(l.CONSTANT, word_match(loadWords(path.."properties.txt"), nil, true))


M._rules = {
  {'whitespace', ws},
  --{'directives', directives},
  {'keyword', keyword},
  {'function', func},
  --{'constant', constant},
  {'identifier', identifier},
  {'string', string},
  {'comment', comment},
  {'number', number},
  --{'operator', operator},
}


M._foldsymbols = {

	_patterns = {'end %l+', '%l+ repeat', 'then ', '%l+'},
  
  [l.KEYWORD] = {
    ['if'] = 1, ['end if'] = -1,
    ['case'] = 1, ['end case'] = -1,
    ['repeat'] = 1, ['end repeat'] = -1,
    ['tell'] = 1, ['end tell'] = -1,
    ['on'] = 1, ['end'] = -1,
    ['then '] = -1,
  }
}

--M._FOLDBYINDENTATION = true

return M
