-- Sort selected text

function sort_text()
  local sel = editor:GetSelText()
  if #sel == 0 then return end

	local eol
	local eolFlag
	
	-- get editor's current EOL (0=CRLF, 1=CR, 2=LF)
	if editor.EOLMode==0 then
		eol = '\r\n'
		eolFlag = string.match(sel, "\n$")
	elseif editor.EOLMode==1 then
		eol = '\r'
		eolFlag = string.match(sel, "\r$")
	else
		eol = '\n'
		eolFlag = string.match(sel, "\r\n$")
	end
		
	-- get table of lines
	local t = {}
	for line in getLines(sel, eol) do
		table.insert (t, line)
	end
		  
	-- sort case sensitive
  --table.sort(t)
  
  -- sort case-insensitive
  table.sort(t, function(t1,t2) return (t1:lower() < t2:lower() ) end )
  
  local out = table.concat(t, eol)
  if eolFlag then out = out..eol end
  
  editor:ReplaceSel(out)
end

scite_Command {
  'Sort Selection|sort_text|Alt+Shift+S',
}
