-----------------------------------------------------------------------
-- for global scripts; switch to "SciteUserHome" for per-user scripts
-----------------------------------------------------------------------
function loadscript(scriptfile)  
  dofile(props["SciteDefaultHome"].."\\scripts\\"..scriptfile)
end

-----------------------------------------------------------------------
-- run selected scripts, silently fails if no extman
-----------------------------------------------------------------------

-- static definition
--local AppList = {
--  {"Tic Tac Toe", "TicTacToe.lua", "TicTacToe"},
--  {"Classic Eliza", "ElizaClassic.lua", "ClassicEliza"},
--}

-- load scripts dynamically from scripts folder
local AppList = {}
local files = readDir(props['SciteDefaultHome'].."\\scripts\\*.lua")
for i,f in ipairs(files) do 
	AppList[i] = {f, f, string.sub(f,1,-5)}
end

function ChooseScript()
  local list = {}
  for i,v in ipairs(AppList) do list[i] = v[1] end
  if scite_UserListShow then
    scite_UserListShow(list, 1, RunSelectedScript)
  end
end

function RunSelectedScript(str)
  for i,v in ipairs(AppList) do
    if str == v[1] then
      loadscript(v[2]) -- change this to suit your environment
      if type(_G[v[3]]) == "function" then _G[v[3]]() end
    end
  end
end

scite_Command('Macro Scripts|ChooseScript|Ctrl+9')
